--------------------------------------------------------------------------------------------------------------
-- ScreenEdge UI ver1.6                                                                                   25/9/2009
--------------------------------------------------------------------------------------------------------------
-- A simple assign method
--
--    1. Enable "Macro Recorder" from MAXScript menu etc.
--    2. Action the command that you want to assign,
--       Then the code is displayed by mini-listener (pink field) of the screen bottom left. (e.g. max move)
--    3. Replace a displayed code in a place of [Command] at left edge/right edge/top edge setting.
--
--   Please write "null" when there is no assign.
--------------------------------------------------------------------------------------------------------------

-- Configure Your Edges ============================================================--

global right_edge_width = 10		-- Right edge width (px)

global Top_edge_width = 0			-- '0' = One display	'1' = Stretch of Top edge to another display
global Bottom_edge_width = 0		-- '0' = One display	'1' = Stretch of Bottom edge to another display

global Floating_board = 1			-- '0' = Invalidity		'1' = Enable
--===============================================================================--




-- Multiplex start check
if classOf LeftBer == RolloutClass do destroyDialog LeftBer
if classOf RightBer == RolloutClass do destroyDialog RightBer
if classOf TopBer == RolloutClass do destroyDialog TopBer
if classOf BottomBer == RolloutClass do destroyDialog BottomBer
if classOf FloatingBoard == RolloutClass do destroydialog FloatingBoard
if classOf EndBer == RolloutClass do destroyDialog EndBer

if Top_edge_width == 1 then Top_edge_width=1 else Top_edge_width=2
if Bottom_edge_width == 1 then Bottom_edge_width=1 else Bottom_edge_width=2


--																			/////////////////////////////////////////////////////
--																										Left edge setting
--																			/////////////////////////////////////////////////////
rollout LeftBer ""
(
	on LeftBer lbuttondblclk null do --										[ Command ]				    [ Button ]
	(
																						max scale						-- Double Click
	)
	on LeftBer lbuttondown null do (
		if keyboard.controlPressed then
																						subobjectLevel = 0			-- Left Click + CTRL
		else if keyboard.shiftPressed then
																						max hide selection			-- Left Click + SHIFT
		else if keyboard.altPressed then
																								null						-- Left Click + ALT
		else 
																						max select					-- Left Click
	)
	on LeftBer rbuttondown null do (	
		if keyboard.controlPressed then
																								null						-- Right Click + CTRL
		else if keyboard.shiftPressed then
																						max  unhide all				-- Right Click + SHIFT
		else if keyboard.altPressed then
																								null						-- Right Click + ALT
		else
																						max   move					-- Right Click
	)
	on LeftBer mbuttondown null do	(
		if keyboard.controlPressed then
																								null						-- Middle Click + CTRL
		else if keyboard.shiftPressed then
																						max  hide inv					-- Middle Click + SHIFT
		else if keyboard.altPressed then
																								null						-- Middle Click + ALT
		else
																						max rotate					-- Middle Click
	)
)
CreateDialog LeftBer 1 sysInfo.desktopSize.y 0 1 style:#()


--																			/////////////////////////////////////////////////////
--																										Right edge setting
--																			/////////////////////////////////////////////////////
rollout RightBer ""
(
	on RightBer lbuttondblclk null do --										[ Command ]				    [ Button ]
	(
																						max tool maximize		-- Double Click
	)
	on RightBer lbuttondown null do	(
		if keyboard.controlPressed then
																						subobjectLevel = 0			-- Left Click + CTRL
 		else if keyboard.shiftPressed then
																								null						-- Left Click + SHIFT
		else if keyboard.altPressed then	
																								null						-- Left Click + ALT
		else
																						max select					-- Left Click
	)
	on RightBer rbuttondown null do	(
		if keyboard.controlPressed then
																						max delete					-- Right Click + CTRL
		else if keyboard.shiftPressed then	
																								null						-- Right Click + SHIFT
		else if keyboard.altPressed then
																								null						-- Right Click + ALT
		else
																						max move						-- Right Click
	)
	on RightBer mbuttondown null do (
		if keyboard.controlPressed then
																								null						-- Middle Click + CTRL
		else if keyboard.shiftPressed then
																								null						-- Middle Click + SHIFT
		else if keyboard.altPressed then
																								null						-- Middle Click + ALT
		else
																						max rotate					-- Middle Click
	)
)
CreateDialog RightBer right_edge_width sysInfo.desktopSize.y (sysInfo.desktopSize.x/2-right_edge_width) 0 style:#()



--																			/////////////////////////////////////////////////////
--																										Top edge setting
--																			/////////////////////////////////////////////////////
rollout TopBer""
(
	on TopBer lbuttondblclk null do --										[ Command ]				    [ Button ]
	(	
																								null						--Double Click
	)
	on TopBer lbuttondown null do	(
		if keyboard.controlPressed then
																						max tool hlist				-- Left Click + CTRL
		else if keyboard.shiftPressed then
																						max vpt front				-- Left Click + SHIFT
		else if keyboard.altPressed then
																						max wire smooth			-- Left Click + ALT
		else
																						max mtledit					-- Left Click
	)
	on TopBer rbuttondown null do (
		if keyboard.controlPressed then
													macros.run "Track View" "LaunchFCurveEditor"	-- Right Click + CTRL
		else if keyboard.shiftPressed then
																						max vpt left					-- Right Click + SHIFT
		else if keyboard.altPressed then
																						max vpt persp user			-- Right Click + ALT
		else
																						max render scene			-- Right Click
	)
	on TopBer mbuttondown null do	(
		if keyboard.controlPressed then
																						max properties				-- Middle Click + CTRL
		else if keyboard.shiftPressed then
																						max vpt top					-- Middle Click + SHIFT
		else if keyboard.altPressed then	
																	actionMan.executeAction 0 "369"		-- Middle Click + ALT
		else
																	actionMan.executeAction 0 "40029"	-- Middle Click
	)
)
CreateDialog TopBer (sysInfo.desktopSize.x/Top_edge_width-1) 1 1 0 style:#()


--																			/////////////////////////////////////////////////////
--																									Bottom edge setting
--																			/////////////////////////////////////////////////////
rollout BottomBer""
(
	on BottomBer lbuttondblclk null do --									[ Command ]				    [ Button ]
	(
																						max tool maximize		-- Double Click
	)
	on BottomBer lbuttondown null do	(
		if keyboard.controlPressed then
																						subobjectLevel = 0			-- Left Click + CTRL
 		else if keyboard.shiftPressed then
																								null						-- Left Click + SHIFT
		else if keyboard.altPressed then
																								null						-- Left Click + ALT
		else
																						max select					-- Left Click
	)
	on BottomBer rbuttondown null do	(
		if keyboard.controlPressed then
																						max delete					-- Right Click + CTRL
		else if keyboard.shiftPressed then	
																								null						-- Right Click + SHIFT
		else if keyboard.altPressed then
																								null						-- Right Click + ALT
		else
																						max move						-- Right Click
	)
	on BottomBer mbuttondown null do (
		if keyboard.controlPressed then
																								null						-- Middle Click + CTRL
		else if keyboard.shiftPressed then
																								null						-- Middle Click + SHIFT
		else if keyboard.altPressed then
																								null						-- Middle Click + ALT
		else
																						max rotate					-- Middle Click
	)

	--on BottomBer mousemove null do (
	--if keyboard.controlPressed then
	--												max rotate						-- Middle Click + CTRL
	--)
)
CreateDialog BottomBer (sysInfo.desktopSize.x/Bottom_edge_width-1) 1 1 (sysInfo.desktopSize.y-1) style:#()

--																			/////////////////////////////////////////////////////
--																										FloatingBoard setting
--																			/////////////////////////////////////////////////////
if Floating_board == 1 then (
rollout FloatingBoard "Click me"
(
	on FloatingBoard lbuttondblclk null do --										[ Command ]				    [ Button ]
	(
																						max tool maximize		-- Double Click
	)
	on FloatingBoard lbuttondown null do	(
		if keyboard.controlPressed then
																						subobjectLevel = 0			-- Left Click + CTRL
 		else if keyboard.shiftPressed then
																								null						-- Left Click + SHIFT
		else if keyboard.altPressed then	
																								null						-- Left Click + ALT
		else
																							max select					-- Left Click
		)
	on FloatingBoard rbuttondown null do	(
		if keyboard.controlPressed then
																						max delete					-- Right Click + CTRL
		else if keyboard.shiftPressed then	
																								null						-- Right Click + SHIFT
		else if keyboard.altPressed then
																								null						-- Right Click + ALT
		else
																							max move						-- Right Click
	)
	on FloatingBoard mbuttondown null do (
		if keyboard.controlPressed then
																								null						-- Middle Click + CTRL
		else if keyboard.shiftPressed then
																								null						-- Middle Click + SHIFT
		else if keyboard.altPressed then
																								null						-- Middle Click + ALT
		else
																						max rotate					-- Middle Click
	)
)
CreateDialog FloatingBoard 60 80 500 500 style:#(#style_titlebar,#style_resizing)
)

------------------------------------------------------------------------------------------------------------------------------
-- End of ScreenEdge UI --------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------
rollout EndBer"" 
(
	on EndBer lbuttondown null do	
	(
		rollout confirm"" 
		(
			label lbl1 "Quit ScreenEdge UI ?" pos:[13,20] width:160 height:16
			-- button quit_btn "Quit" pos:[20,15] width:60 height:24

			on confirm  lbuttondown null do
			(
				destroydialog LeftBer
				destroydialog RightBer
				destroydialog TopBer
				destroydialog BottomBer
				if classOf FloatingBoard == RolloutClass do destroydialog FloatingBoard
				destroydialog EndBer
				destroydialog confirm
				)
			on confirm  rbuttondown null do
			(
				destroydialog confirm
			)
		)
		CreateDialog confirm 140 55 -5 -5 bgcolor: Black  fgcolor: white modal: true style:#(#style_border)
	)
)
CreateDialog EndBer 1 1 0 0 style:#()

-- ---- License & Thanks ----
-- This script is 100% free.You are free to distribute this script as you wish.
-- The author takes no responsibility for any damages this script may cause, use at your own risk.
-- Thanks: Mr.Masayuki Sato
-- Copyright 2009 Yamat E-mail: yamakawa777@ac.auone-net.jp